//
//  DotEmuChannelViewController.h
//  DotEmuChannel
//
//  Created by DotEmu on 27/09/10.
//  Copyright DotEmu 2010. All rights reserved.
//  Author: Guillaume SIORAK
//  Email: guillaume.siorak@dotemu.com
//

#import <UIKit/UIKit.h>

typedef struct 
{
	int       gameID;
	NSString* gameName;
	UIImage*  gameImg;
	NSString* gameURL;
} DEGames;

@interface DotEmuChannelViewController : UIViewController<UIScrollViewDelegate,NSXMLParserDelegate,UITextFieldDelegate>
{
	//OUTLETS
	IBOutlet UIImageView*             _background;
	IBOutlet UIScrollView*            _scrollView;
	IBOutlet UIActivityIndicatorView* _activityIndicator;
	IBOutlet UIButton*                _back;
	
	IBOutlet UITextField* _emailToGet;
	IBOutlet UIButton* _sendEmail;	

	//ATTRIBUTES
	UIButton*      _GamesB[50];
	
	//GAMES
	int     GAMES_TOTAL;
	int     currentID;
	DEGames _Games[50];
	
	//XML
	NSMutableData*   storeData;	
	NSMutableData*   emailData;	
	bool emailNSURL;
	
	//LANGUAGES
	NSArray*  _languages;
	NSString* _preferredLang;	
}

//ACTIONS
- (IBAction) backButtonClicked:(id)sender;
- (IBAction) gameClicked:(id)sender;
- (IBAction) submitClicked:(id)sender;

//METHODS
- (void) loadGames:(int)iid;
- (void) clearGames:(int)iid;

//DELEGATES
- (BOOL) textFieldShouldReturn:(UITextField *)textField;
- (void) textFieldDidBeginEditing:(UITextField *)textField;

@end

