//
//  DotEmuChannelViewController.h
//  DotEmuChannel
//
//  Created by DotEmu on 27/09/10.
//  Copyright DotEmu 2010. All rights reserved.
//  Author: Guillaume SIORAK
//  Email: guillaume.siorak@dotemu.com
//

#import "DotEmuChannelViewController.h"
#import "iphone_common.h"
#import "iphone_main.h"
#import "Reachability.h"

int _netR;
extern NSString* STORE_GAME;

@implementation DotEmuChannelViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
	//LANGUAGE 
	_languages = [NSLocale preferredLanguages];
    _preferredLang = [[_languages objectAtIndex:0] retain];
	
	//BACKGROUND
	_background = [[UIImageView alloc] initWithFrame:CGRectMake( 0, 0, 320, 480 )];  
	[_background setImage:[UIImage imageNamed:@"DotEmuChannel_background.png"]];  
	[self.view addSubview:_background];
	
	//SCROLLVIEW
	[_scrollView setContentSize:CGSizeMake( 320, 1200 ) ];
	[self.view insertSubview:_scrollView aboveSubview:_background];
	
	//BUTTONS
	_back.enabled = YES;
	[self.view insertSubview:_back aboveSubview:_background];
	
	//TEXTFIELD + BUTTON EMAIL
	if( [_preferredLang isEqualToString:@"en"] )
	{
		[_emailToGet setPlaceholder:@"Enter your email here..."];
		[_sendEmail setTitle:@"Submit" forState:UIControlStateNormal];
	}
	else if( [_preferredLang isEqualToString:@"fr"] )
	{
		[_emailToGet setPlaceholder:@"Entrez votre adresse email ici..."];
		[_sendEmail setTitle:@"Envoyer" forState:UIControlStateNormal];		
	}
	
	[self.view insertSubview:_emailToGet aboveSubview:_background];
	[self.view insertSubview:_sendEmail aboveSubview:_background];
	
	//DEFAULT USER
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	if( [defaults boolForKey:STORE_GAME] == NO )
	{
		[defaults setBool:YES forKey:STORE_GAME];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"storeUpdateOffNotif" object:nil];		
	}
	[[NSUserDefaults standardUserDefaults] synchronize];
	
	//SUPER
    [super viewDidLoad];
}

-(void) touchesBegan :(NSSet *) touches withEvent:(UIEvent *)event
{
	NSLog(@"touches began");
	[_emailToGet resignFirstResponder];
	
	[super touchesBegan:touches withEvent:event];
}

- (IBAction) submitClicked:(id)sender
{
	emailNSURL = true;	
}

- (void)XMLLoading
{
	// Create the request.
	NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:@"http://corporate.dotemu.com/new_iPhoneStore.xml"]
											  cachePolicy:NSURLRequestUseProtocolCachePolicy
										  timeoutInterval:60.0];
	
	// create the connection with the request and start loading the data
	NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	if (theConnection) 
	{
		NSLog(@"connection OK");	
	    storeData = [[NSMutableData data] retain];
	} 
	else 
	{
		// Inform the user that the connection failed.
		NSLog(@"connection failed");
	}	
	emailNSURL = false;	
}

- (void) noInternetLoading
{
	NSLog(@"noInternetLoading");

	_activityIndicator.hidden = YES;
	[_activityIndicator stopAnimating];
	
	if( _scrollView != nil )
	{
		[_scrollView removeFromSuperview];		
		[_scrollView release];
		_scrollView = nil;
	}
	if( _activityIndicator != nil )
	{
		[_activityIndicator removeFromSuperview];		
		[_activityIndicator release];
		_activityIndicator = nil;
	}
}

- (void)viewDidAppear:(BOOL)animated
{
	_emailToGet.hidden = YES;
	_sendEmail.hidden = YES;
	
	emailNSURL = false;
	
	_activityIndicator.hidden = NO;
	[_activityIndicator startAnimating];
	[self.view insertSubview:_activityIndicator aboveSubview:_background];
	
	//network ?
	Reachability* reachability = [Reachability reachabilityWithHostName:@"www.apple.com"];
	NetworkStatus remoteHostStatus = [reachability currentReachabilityStatus];
	
	if(remoteHostStatus == NotReachable) { NSLog(@"not reachable"); _netR = 0; }
	else if (remoteHostStatus == ReachableViaWWAN) { NSLog(@"reachable via wwan"); _netR = 1; }
	else if (remoteHostStatus == ReachableViaWiFi) { NSLog(@"reachable via wifi"); _netR = 2; }

	if( _netR == 0 )
	{
		[NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(noInternetLoading) userInfo:nil repeats:NO];	
	}
	else
	{
		[NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(XMLLoading) userInfo:nil repeats:NO];	
	}
}


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait];
	return UIInterfaceOrientationPortrait;
	
    // Return YES for supported orientations
    //return UIDeviceOrientationIsPortrait(interfaceOrientation);
}

- (void)viewWillAppear:(BOOL)animated
{
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
}

- (void)didReceiveMemoryWarning
{
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc
{
	NSLog(@"DotEmuChannelViewController dealloc");
	
	//OUTLETS
	if( _background != nil )
	{
		[_background removeFromSuperview];		
		[_background release];
		_background = nil;
	}
	if( _scrollView != nil )
	{
		[_scrollView removeFromSuperview];		
		[_scrollView release];
		_scrollView = nil;
	}
	if( _activityIndicator != nil )
	{
		[_activityIndicator removeFromSuperview];		
		[_activityIndicator release];
		_activityIndicator = nil;
	}
	if( _back != nil )
	{
		[_back removeFromSuperview];		
		[_back release];
		_back = nil;
	}
	
	//ATTRIBUTES
	for( int i = 0; i < 50; ++i )
	{
		if( _GamesB[i] != nil )
		{
			[_GamesB[i] removeFromSuperview];		
			[_GamesB[i] release];
			_GamesB[i] = nil;
		}
	}
	
	//GAMES
	for( int i = 0; i < 50; ++i )
	{
		if( _Games[i].gameName != nil )
		{	
			//[_Games[i].gameImg release];
			_Games[i].gameName = nil;
		}
		if( _Games[i].gameImg != nil )
		{	
			//[_Games[i].gameImg release];
			_Games[i].gameImg = nil;
		}
		if( _Games[i].gameURL != nil )
		{		
			//[_Games[i].gameURL release];
			_Games[i].gameURL = nil;
		}
	}
	
	//XML
	if( storeData != nil )
	{
		[storeData release];
		storeData = nil;
	}
	if( emailData != nil )
	{
		[emailData release];
		emailData = nil;
	}
	
	//LANGUAGES
	if( _languages != nil )
	{
		//[_languages release];
		_languages = nil;
	}
	if( _preferredLang != nil )
	{
		//[_preferredLang release];
		_preferredLang = nil;
	}

    [super dealloc];
} 

//METHODS

int decrem = 0;
- (void) loadGames:(int)iid
{
	NSLog(@"DotEmuChannelViewController loadGames:(int)%d",iid);

	if( [_Games[iid].gameName isEqualToString:[[[[NSBundle mainBundle] bundlePath] lastPathComponent] stringByDeletingPathExtension]] )
	{
		decrem = 1;
		[_scrollView setContentSize:CGSizeMake( 280, (GAMES_TOTAL-decrem)*150 + 40 ) ];
		return;
	}
	
	_GamesB[iid] = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
	if( iid == 0 )
		_GamesB[iid].frame = CGRectMake( 25, 35, 57, 57 );
	else
		_GamesB[iid].frame = CGRectMake( 25, ((iid-decrem)*150)+40, 57, 57 );
	[_GamesB[iid] setImage:_Games[iid].gameImg forState:UIControlStateNormal]; 		
	[_GamesB[iid] addTarget:self action:@selector(gameClicked:) forControlEvents:UIControlEventTouchDown];	
	
	_GamesB[iid].hidden = YES;

	[_scrollView addSubview:_GamesB[iid]]; 
}

- (void) clearGames:(int)iid
{
	if( _GamesB[iid] != nil && _GamesB[iid].superview != nil )
	{
		[_GamesB[iid] removeFromSuperview];
		[_GamesB[iid] release];
		_GamesB[iid] = nil;
	}
}

//ACTIONS
- (IBAction) backButtonClicked:(id)sender
{
	NSLog(@"DotEmuChannelViewController backButtonClicked");
	_back.enabled = NO;
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"enableMenuUINotif" object:nil];	
	
	[(iPhoneMain*)[[UIApplication sharedApplication] delegate] switchToLandscapeView];
}

- (IBAction) gameClicked:(id)sender
{
	NSLog(@"DotEmuChannelViewController gameClicked");
	for( int i = 0; i < GAMES_TOTAL; ++i )
	{
		if( _GamesB[i] == sender )
			[[UIApplication sharedApplication] openURL:[NSURL URLWithString:_Games[i].gameURL ]];		
	}
}

//XML DELEGATES
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName 
	attributes:(NSDictionary *)attributeDict 
{	
	NSLog(@"parser didStartElement %@",elementName);

	NSString *ss;
	
	if([elementName isEqualToString:@"NOMBRE_JEUX"])
	{
		GAMES_TOTAL = [[attributeDict objectForKey:@"nb"] integerValue];
		[_scrollView setContentSize:CGSizeMake( 280, GAMES_TOTAL*150 + 40 ) ];		
	}
	if([elementName isEqualToString:@"GAME"])
	{
		currentID = [[attributeDict objectForKey:@"ID"] integerValue];
		_Games[currentID].gameID = currentID;	
	}
	if([elementName isEqualToString:@"NAME"])
	{
		ss = [attributeDict objectForKey:@"name"];
		_Games[currentID].gameName = ss;	
	}
	if([elementName isEqualToString:@"IMG"])
	{
		ss = [attributeDict objectForKey:@"img"];
		UIImage *img = [[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:ss]]];
		_Games[currentID].gameImg = img;		
	}
	if([elementName isEqualToString:@"URL"])
	{
		ss = [[attributeDict objectForKey:@"url"] retain];
		_Games[currentID].gameURL = ss;
	}
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string 
{	

}

- (void) showUI
{
	_activityIndicator.hidden = YES;
	[_activityIndicator stopAnimating];		

	_emailToGet.hidden = NO;
	_sendEmail.hidden = NO;
	
	for( int i = 0; i < GAMES_TOTAL; ++i )
	{
		if( _GamesB[i] )
			_GamesB[i].hidden = NO;
	}	
}

- (void) scrollToTop
{
	[_scrollView setContentOffset:CGPointMake(0.0,0.0) animated:NO];
	[NSTimer scheduledTimerWithTimeInterval:0.15 target:self selector:@selector(showUI) userInfo:nil repeats:NO];	
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
	NSLog(@"parser didEndElement %@",elementName);
	
	//LOAD GAME
	if([elementName isEqualToString:@"STORE"])
	{
		for( int i = 0; i < GAMES_TOTAL; ++i )
		{
			[self clearGames:i];
			[self loadGames:i];
		}
		[NSTimer scheduledTimerWithTimeInterval:0.35 target:self selector:@selector(scrollToTop) userInfo:nil repeats:NO];	
	}
}

//NSURLCONNECTION
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    NSLog(@"didReceiveResponse");	

	// This method is called when the server has determined that it
	// has enough information to create the NSURLResponse.
	
	
	// It can be called multiple times, for example in the case of a
	// redirect, so each time we reset the data.
	
	// receivedData is an instance variable declared elsewhere.
	
	if( !emailNSURL )
	{
		_activityIndicator.hidden = NO;
		[_activityIndicator startAnimating];
		
		[storeData setLength:0];
	}
	else
	{
		[emailData setLength:0];		
	}
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    NSLog(@"didReceiveData");
	
    // Append the new data to receivedData.
    // receivedData is an instance variable declared elsewhere.
	
	if( !emailNSURL )
		[storeData appendData:data];
	else
		[emailData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    // release the connection, and the data object
    [connection release];
	
    // receivedData is declared as a method instance elsewhere
	
	if( !emailNSURL )
	{
		[storeData release];
		storeData = nil;
	}
	else
	{
		[emailData release];
		emailData = nil;		
	}
	
    // inform the user
    //NSLog(@"connectiondidFailWithError - Connection failed! Error - %@ %@",
    //      [error localizedDescription],
     //     [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]);
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    // do something with the data
    // receivedData is declared as a method instance elsewhere
	
	if( !emailNSURL )
	{
		NSLog(@"connectionDidFinishLoading - Succeeded! Received %d bytes of data",[storeData length]);
		
		_activityIndicator.hidden = YES;
		[_activityIndicator stopAnimating];
		
		NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:storeData];
		
		//Set delegate
		[xmlParser setDelegate:self];
		
		//Start parsing the XML file.
		[xmlParser parse];	
		
		// release the connection, and the data object
		[xmlParser release];
		[connection release];
		[storeData release];
		storeData = nil;
	}
	else
	{
		NSLog(@"connectionDidFinishLoading - Succeeded! Received %d bytes of data",[emailData length]);
		
		[connection release];
		[emailData release];
		emailData = nil;		
	}
}

//UITEXTFIELDDELEGATE
- (BOOL) textFieldShouldReturn:(UITextField *)textField
{
    // the user pressed the "Done" button, so dismiss the keyboard
    [textField resignFirstResponder];
	
    return YES;
}

- (void) textFieldDidBeginEditing:(UITextField *)textField;
{
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait];	
    [textField setPlaceholder:@""];	
}

- (void) textFieldDidEndEditing:(UITextField *)textField
{
	if( [textField.text isEqualToString:@""] )
	{
		if( [_preferredLang isEqualToString:@"en"] )
		{
			[_emailToGet setPlaceholder:@"Enter your email here..."];
		}
		else if( [_preferredLang isEqualToString:@"fr"] )
		{
			[_emailToGet setPlaceholder:@"Entrez votre adresse email ici..."];	
		}
	}
}

@end
