//
//  menuigViewController.mm
//  scummvm
//
//  Created by DotEmu on 19/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#include <semaphore.h>
#import <engines/igob/gob.h>
#import "switchViewController.h"
#import "iPhoneViewController.h"
#import "menuigViewController.h"
#import "iphone_common.h"

//////////////////
//---GAME PARAMS
//LVL (SIMULATION)
extern int etat;
//GAME (GENERAL)
extern bool bTutoOn;
extern bool bMenuIngame;
extern bool bFromMenuIngame;
extern bool bMenuGob1;
extern bool bSleepMode;
extern bool bLoad;
bool bSaveActive = true;
//SOUND
extern int idSoundSFX;
//DEFINES
extern iPhoneViewController* g_iVC;
extern switchViewController* g_switchVC;
extern menuigViewController* g_menuigVC;
//---END
////////////////

extern bool bSem;
extern sem_t* sem;

@implementation menuigViewController
@synthesize _settingsVC;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	NSLog(@"menuigViewController viewDidLoad");
	
	_resume.hidden = NO;	
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-25.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	if( bTutoOn )
	{
		_save.enabled = NO;
		_load.enabled = NO;
	}
	else
	{
		_save.enabled = YES;
		_load.enabled = YES;
	}
	
    [super viewDidLoad];	
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning 
{
	NSLog(@"menuigViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	NSLog(@"menuigViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc
{
	NSLog(@"menuigViewController dealloc");	

	if( _resume != nil )
	{
		[_resume release];
		_resume = nil;
	}
	if( _save != nil )
	{
		[_save release];
		_save = nil;
	}
	if( _load != nil )
	{
		[_load release];
		_load = nil;
	}
	if( _settingsVC != nil )
	{
		[_settingsVC release];
		_settingsVC = nil;
	}
	
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	
    [super dealloc];
}

-(void) resume
{
	[self.view removeFromSuperview];
}

-(IBAction) resumeClicked:(id)sender
{
	NSLog(@"menuigViewController resumeClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( bMenuIngame )
	{
		bMenuIngame = false;
		bSleepMode = false;
		if( bSem )
		{
			sem_post( sem );		
			bSem = false;
		}	
		[NSTimer scheduledTimerWithTimeInterval:0.35 target:self selector:@selector(resume) userInfo:nil repeats:NO];
	}
}

-(IBAction) saveClicked:(id)sender
{
	NSLog(@"menuigViewController saveClicked");
	bSaveActive = true;

	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( !bFromMenuIngame && bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		g_menuigVC = self;
		[self.view removeFromSuperview];
		[g_switchVC switchSave];
	}
}

-(IBAction) loadClicked:(id)sender
{
	NSLog(@"menuigViewController loadClicked");
	bSaveActive = false;
	bLoad = true;

	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( !bFromMenuIngame && bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		g_menuigVC = self;
		[self.view removeFromSuperview];
		[g_switchVC switchSave];
	}
}

-(IBAction) settingsIGClicked:(id)sender
{
	NSLog(@"menuigViewController settingsIGClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( !bFromMenuIngame && bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		g_menuigVC = self;
		[self.view removeFromSuperview];
		[g_switchVC switchSettingsInGame];
	}
}

-(IBAction) quitClicked:(id)sender
{
	NSLog(@"menuigViewController quitClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		bMenuGob1 = true;
		bSleepMode = false;
		if( bSem )
		{
			sem_post( sem );		
			bSem = false;
		}
		[[NSNotificationCenter defaultCenter] postNotificationName:@"endTutoAgainNotif" object:nil];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"hideButtonsNotif" object:nil];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"muteNotif" object:nil];			

		[g_switchVC switchViews];	
		
		[self.view removeFromSuperview];
		
		g_menuigVC = nil;
	}
}

@end
